plugin helper RenderHolder
name:"RenderHolder" 
classID:#(0x69e4e245, 0x59465a1a)
category:"Zorb" 
extends:dummy

( 
	local lastSize, meshObj 
	local tok = "\x01"
	
	fn MakeTheMatsCopys =
	(
		for i = 1 to this.theMats.count do
		(
			
			local ad = getappdata this.theMats[i] 2000
			this.theMats[i] = copy this.theMats[i]
			if ad != undefined then setappdata this.theMats[i] 2000 ad
		)
	)	
	
	fn recordFilenameToMat theFilename: =
	(
		fnName = "RenderHolder.recordFilenameToMat"
		zc.AddLog #(fnName,  "Starting", 5)
		if theFilename == unsupplied then theFilename = (maxfilepath + maxfilename)
		if theFilename != "" then
		(
			for m in this.theMats do setappdata m 2000 theFilename
			return theFilename
		)
		else return false
	)
	
	fn getAssetNameFromAppdata mat =
	(
		fnName = "RenderHolder.getAssetNameFromAppdata"
		zc.AddLog #(fnName,  "Starting", 5)
		zc.AddLog #(fnName,  ("processing Material: "+mat.name), 5)
		theappdata = getappdata mat 2000
		if theappdata != undefined then
		(
			filteredAssetName = filterstring (getfilenamefile theappdata) "_"
			local theAssetVersion = filteredAssetName[filteredAssetName.count]
			local theAssetName = ""
			for i in filteredAssetName where i != filteredAssetName[filteredAssetName.count]do
			(
				append theAssetName (i+"_")
			)
			theAssetName = trimright theAssetName "_"
			zc.AddLog #(fnName,  ("Material: "+mat.name+", found asset name: "+theAssetName+", version: "+theAssetVersion), 4)
			return #(theAssetName, theAssetVersion)
		)
		else return undefined
	)
	
	fn SkipBloodyDialogs  =
	(
		WindowHandle = DialogMonitorOPS.GetWindowHandle()
		--print (UIAccessor.GetWindowText WindowHandle)
		if (UIAccessor.GetWindowText WindowHandle) == "RPMInitialising" then UIAccessor.PressButtonByName WindowHandle "No"
		if (UIAccessor.GetWindowText WindowHandle) == "Save File As" then UIAccessor.PressButtonByName WindowHandle "Cancel"
		if (UIAccessor.GetWindowText WindowHandle) == "MAXScript " then UIAccessor.PressDefaultButton()
		true
	)
	
	fn searchMatSubanims sa theAssetName collectArr =
	(
		fnName = "RenderHolder.searchMatSubanims"
		zc.AddLog #(fnName,  "Starting", 5)
		assetName = getAssetNameFromAppdata sa.object
		if assetName != undefined and assetName[1] == theAssetName[1] then
		(
			zc.AddLog #(fnName,  ("Found matching asset "+(assetName as string)+" on material "+sa.object.name), 4)
			append collectArr sa
		)
		for i = 1 to sa.numsubs where (superclassof sa[i].object == material) do
		(
			searchMatSubanims sa[i] theAssetName collectArr
		)
	)
	
	fn BuildRPMpass passindex startFrame: endFrame: thePassName: =
	(
		global RPMData, RPMDataNet, RPmanrell, RPMVisSets
		if thePassName == unsupplied then thePassName=this.passName
		if passindex == 0 then --Pass not found, Build one!
		(
			--append theLogArr #(("RPM Setup: Adding "+this.passName+" pass"), "info")
			zc.AddLog #(fnName,  "RPM Setup: Adding "+thePassName+" pass", 4)
			RPMdata.AddPassSetup setname:thePassName noEdit:true
			--get passindex for the new pass
			for p = 1 to (RPMdata.GetPassCount()) do
			(
				thePassName = RPMdata.GetPassName p
				if thepassName == thePassName then
				(
					passindex = p
				)
			)
			PassID = (RPMData.rmgetstordata passindex)
			--setup deadline settings
			--with printAllElements on
			
			with printAllElements on theNetData =(RPMDataNet.CustomSubmitStruct.GetDeadline4DataByNumb PassID)
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #LimitEnabled do theNetData[nd][2]= true
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #MachineLimit do theNetData[nd][2]= 20
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #RenderFramesPreviewJob do theNetData[nd][2]= true
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #Slaves do theNetData[nd][2]= #("")
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #ShowFrameBuffer do theNetData[nd][2]= false
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #RenderElementsUpdateFilenames do theNetData[nd][2]= false
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #RenderElementsPermanentChanges do theNetData[nd][2]= false
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #RenderElementsUpdatePaths do theNetData[nd][2]= false
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #PoolName do theNetData[nd][2]= "film_max"
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #group do theNetData[nd][2]= "8g"
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #Priority do theNetData[nd][2]= 50
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #TaskTimeoutEnabled do theNetData[nd][2]= true
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #tasktimeout do theNetData[nd][2]= 7200
			for nd = 1 to theNetData.count  where theNetData[nd][1] == #AutoTaskTimeout do theNetData[nd][2]= true
				
			with printAllElements on RPMDataNet.CustomSubmitStruct.SetDeadline4DataByNumb PassID theNetData
			zc.AddLog #(fnName,  ("RPM Setup: Added "+thePassName+" Network Data"), 4)
			--append theLogArr #(("RPM Setup: Added "+this.passName+" Network Data"), "result")
			
			--Turn On AutoPath:
			RPMData.RMModifyValues 68 numbarray:#(passindex) input:true
			--Set Time Output to Range
			RPMData.RMModifyValues 2 numbarray:#(passindex) input:3
			--Set Render Range to animation range
			
			zc.AddLog #(fnName,  ("RPM Setup: startFrame: "+startFrame as string+", endframe: "+endFrame as string), 5)
			if startFrame == unsupplied or endframe == unsupplied or classof startFrame != integer or classof endFrame != integer then
			(
				RPMdata.SetPassRange passindex [((animationrange.start as integer)/TicksPerFrame), ((animationrange.end as integer)/TicksPerFrame)]
			)
			else RPMdata.SetPassRange passindex [(startFrame), (endframe)]
			--set setero camera folder names
			RPMData.RMModifyValues 82 numbarray:#(passindex) input:#("Ignore", "SR.")
			RPMData.RMModifyValues 83 numbarray:#(passindex) input:#("Ignore", "SL.")
			
			--set custom: Auto Create Stereo Node
			try (RPMdata.SetCustPassStorage passindex 1 false) catch()
			
			if this.theRenderer.classid[1] == 1941615238 and this.theRenderer.classid[2] == 2012806412 then --its a Vray Pass
			(
				-- turnoff Max default save rendered file (so only Vray exr save file is enabled)
				RPMData.RMModifyValues 78 numbarray:#(passindex) input:false	
				--turn off VFB for Vray pass
				RPMData.RMModifyValues 10 numbarray:#(passindex) input:false
				--Turn off display render elements
				RPMData.relementmodifyvalues 2 input:false passarray=#(passindex)
			)
			if this.theRenderer.classid[1] == 217131703 and this.theRenderer.classid[2] == 58075251 then
			(
				--turn on VFB for fR pass
				RPMData.RMModifyValues 10 numbarray:#(passindex) input:true		
			)
			
			--setupVis Sets
			AllObjs = #()
			for m = 1 to this.theMats.count do
			(
				theRenderers = (filterstring this.theMatObjs[m] tok)
				for o in theRenderers do
				(
					theRenderer = getnodebyname o
					if theRenderer != undefined then append AllObjs theRenderer
				)
				
			)
			--get objects from the this.theXVisObjs to add to vis set
			for o in this.theXVisObjs do
			(
				theRenderer = getnodebyname o
				if theRenderer != undefined then append AllObjs theRenderer
			)
			
			
			--create vis set
			RPMVisSets.createVisibilitySet AllObjs thePassName
			--assign vis set to path
			RPMData.RMModifyValues 28 numbarray:#(passindex) input:thePassName	
			
			--set before script to unhide all vrayStereoHelpers.. man i hate those god damn helpers, why couldnt it just be in the camera paet of the render settings??? 
			--RPMdata.SetPassBeforeScript passindex "for i in objects where classof i == VRayStereoscopic do i.ishidden =false" quiet:false 
			
			rpmdata.fitLstbox()
			zc.AddLog #(fnName,  ("RPM Setup: Built "+thePassName+" pass at index: "+(passindex as string)), 4)
			return passindex
		)
		else
		(
			zc.AddLog #(fnName,  ("RPM Setup: Updating "+thePassName+" pass"), 4)
			zc.AddLog #(fnName,  ("RPM Setup: Updating not supported yet pass... sorry"), 2)
		)
		
	)
	
	fn applyRenderToRPM passIndex=
	(
		
		--this.passName = (refs.dependentNodes this firstOnly:true).name
		fnName = "RenderHolder.applyRenderToRPM"
		zc.AddLog #(fnName,  "Starting", 5)
		global RPMData, RPMDataNet, RPmanrell, RPMVisSets
		--Apply the renderer
		local thelogArr = #()
		PassID = (RPMData.rmgetstordata passindex)
		
		RPMData.SetRenderer passindex (copy this.theRenderer)
		theRenderTrack = (getProperty TrackViewNodes.RenderPassManager.Rendermanager_Renderers ("renderers_"+(PassID as string))).RendererStore
		--append thelogArr #(("RPM Setup: Render settings appplied to "+this.passName+" pass"), "result")
		zc.AddLog #(fnName,  "RPM Setup: Render settings appplied to "+this.passName+" pass", 4)
		
		return theLogArr
	)
	
	fn applyRenderToRPMREs passIndex doAppend:false=
	(
		
		--this.passName = (refs.dependentNodes this firstOnly:true).name
		fnName = "RenderHolder.applyRenderToRPMREs"
		zc.AddLog #(fnName,  "Starting", 5)
		global RPMData, RPMDataNet, RPmanrell, RPMVisSets
		--Apply the renderer
		local thelogArr = #()
		PassID = (RPMData.rmgetstordata passindex)
		
		--Apply the REs
		--set up REs for capture
		theReMgr = MaxOps.GetCurRenderElementMgr()
		theReMgr.RemoveAllRenderElements()
		if doAppend then --if appending test to see if any render elements exist in the pass
		(
			thePassRENames = for re = 1 to RPManREll.getREllCount passIndex collect (RPManREll.getREll passIndex re).elementName
			for i in this.theREs do
			(
				if (finditem thePassRENames i.elementName) == 0 then theREMgr.AddRenderElement (copy i)
			)
		)
		else for i in this.theREs do theREMgr.AddRenderElement (copy i)
		
		--clear RPM REs if not appending
		if not doAppend then
		(
			numels = rpmanrell.getrellcount passIndex
			for i in 1 to numels do
				rpmanrell.delrell #(passIndex) #(1)
		)
		--capture REs!
		rpmanrell.captureExistingRELL true PassID
		--append thelogArr #(("RPM Setup: Render Elemets appplied to "+this.passName+" pass"), "result")
		zc.AddLog #(fnName,  "RPM Setup: Render Elemets appplied to "+this.passName+" pass", 4)
		
		return theLogArr
	)
	
	fn applyMatsToRPM passIndex buildRPMmat:true forceRebuild:false=
	(
		global RPMData, RPMDataNet, RPmanrell, RPMVisSets
		--this.passName = (refs.dependentNodes this firstOnly:true).name
		fnName = "RenderHolder.applyMatsToRPM"
		zc.AddLog #(fnName,  "Starting", 5)
		
		local thelogArr = #()
		PassID = (RPMData.rmgetstordata passindex)
		zc.AddLog #(fnName,  ("RPM Material Setup: begin material setup for "+this.passName), 4)
		--append thelogArr #(("RPM Material Setup: begin material setup for "+this.passName), "result")
		
		--RPMclearscenematerials() -- clear scenematerials for speeeeeed!
		
		for m = 1 to this.theMats.count do
		(
			theMat = this.theMats[m]
			theAssetName = getAssetNameFromAppdata theMat --get asset name material originated from
			theRenderers = (filterstring this.theMatObjs[m] tok)
			local collectedMats = #()
			for o in theRenderers do
			(
				
				theRenderer = getnodebyname o
				if theRenderer != undefined then 
				(
					local NoMatAssigend = true-- to keep track of wether the new material was assigned
					currentMat = theRenderer.material
					currentMatSA = theRenderer[5] --gets the material as a subanim
					zc.AddLog #(fnName,  ("Classof CurrentMat: "+((classof CurrentMat) as string)), 5)
					
					if currentMat == undefined then
					(
						zc.AddLog #(fnName,  ("RPM Material Setup: No Material found, forcing rebuild on $"+o), 4)
						forceRebuild = true
					)
					
					if forceRebuild then
					(
						zc.AddLog #(fnName,  ("RPM Material Setup: Forcing rebuild on $"+o), 4)
						if buildRPMmat then
						(
							if classof currentMat == RPMmaterial then --Force Rebuild, RPM material, RPM material found
							(
								currentMat.materialArray[passIndex] = theMat
								currentMat.Labels[passIndex] = this.passName
								zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+" successfully rebulit to RPM material slot on $"+o+" "), 4)
								--append theLogArr #(("RPM Material Setup: Material: "+theMat.name+"successfully assigned to empty RPM material slot on $"+o+" "), "result")		
							)
							else  --Force Rebuild, RPM material, RPM material not found
							(
								theRPMmat = RPMmaterial()
								theRPMmat.materialArray[passIndex] = theMat
								theRPMmat.Labels[passIndex] = this.passName
								theRenderer.material = theRPMmat
								zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+" on RPM Material assigned to $"+o+" successfully"), 4)
								--append theLogArr #(("RPM Material Setup: Material: "+theMat.name+" on RPM Material assigned to $"+o+" successfully"), "result")
							)
						)
						else --Force Rebuild, no RPM material
						(
							theRenderer.material = theMat
							zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+" rebuilt to $"+o+" successfully"), 4)
							--append theLogArr #(("RPM Material Setup: Material: "+theMat.name+" assigned to $"+o+" successfully"), "result")
						)
					)
					else --No Force Rebuild
					(
						if theAssetName != undefined then
						(
							if classof currentMat == RPMmaterial and currentMat.materialArray[passIndex] == undefined then --if found an empty slot in the correct position, just add material
							(
								currentMat.materialArray[passIndex] = theMat
								zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+"successfully assigned to empty RPM material slot on $"+o+" "), 4)
								--append theLogArr #(("RPM Material Setup: Material: "+theMat.name+"successfully assigned to empty RPM material slot on $"+o+" "), "result")								
							)
							
							else --
							(
								zc.AddLog #(fnName,  ("RPM Material Setup: existing material found on $"+o+" trying to update intelligently"), 4)
								--set up material prior to searching for mat to replace
								if classof currentMat != RPMmaterial and buildRPMmat then --convert current to RPM material ready for searching
								(
									theRPMmat = RPMmaterial()
									theRPMmat.materialArray[passIndex] = currentMat
									theRPMmat.Labels[passIndex] = this.passName
									theRenderer.material = theRPMmat
									zc.AddLog #(fnName,  ("RPM Material Setup: Material: $"+o+"'s material converted to RPM"), 4)
									--append theLogArr #(("RPM Material Setup: Material: $"+o+"'s material converted to RPM"), "result")
								)
								
								
								--search for mat to replace based on asset name
								if classof currentMat == RPMmaterial then matToSearch = currentMatSA[passIndex] else matToSearch = currentMatSA
								
								searchMatSubanims matToSearch theAssetName collectedMats
								zc.AddLog #(fnName,  ("RPM Material Setup: Material: $"+o+"'s material converted to RPM"), 4)
							)
						)
						else --didnt find asset name, but will add material if nothing is there
						(
							if currentMat == undefined then
							(
								zc.AddLog #(fnName,  ("RPM Material Setup: Could not find Asset name from material: "+theMat.name+", trying to non-destructivley assign anyway"), 4)
								if buildRPMmat then
								(
									theRPMmat = RPMmaterial()
									theRPMmat.materialArray[passIndex] = theMat
									theRPMmat.Labels[passIndex] = this.passName
									theRenderer.material = theRPMmat
									zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+"successfully rebulit to RPM material slot on $"+o+" "), 4)
								)
								else
								(
									theRenderer.material = theMat
									zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+" rebuilt to $"+o+" successfully"), 4)									
								)
							)
							
							if classof currentMat == RPMmaterial and currentMat.materialArray[passIndex] == undefined then
							(
								currentMat.materialArray[passIndex] = theMat
								currentMat.Labels[passIndex] = this.passName
								zc.AddLog #(fnName,  ("RPM Material Setup: Material: "+theMat.name+"successfully assigned to empty RPM material slot on $"+o+" "), 4)
							)
						)
						--append theLogArr #(("RPM Material Setup: Could not find Asset name from material: "+theMat.name), "error")				
					)
				)
				else zc.AddLog #(fnName,  ("RPM Material Setup: $"+o+" not found. Skipping material assignement"), 3)
				--append theLogArr #(("RPM Material Setup: $"+o+" not found. Skipping material assignement"), "info")
			)
			--this.theMats[1] = copy this.theMats[1]
			
			--Check to see if any materials were collected for replacement
			if collectedMats.count != 0 then
			(
				zc.AddLog #(fnName,  ("RPM Material Setup: Found materials by asset to replace."), 5)
				collectedMats = makeuniquearray collectedMats
				
				for cm in collectedMats do
				(
					zc.AddLog #(fnName,  ("RPM Material Setup: Updated "+cm.name+" to version "+theAssetName[2]), 4)
					replaceinstances cm theMat
				)
				
			)
		)
		MakeTheMatsCopys()
		return theLogArr
	)
	
	fn InstMats2Medit theMats =
	(
		--clearMedit
		for i = 1 to 24 do
		(
			meditmaterials[i] = standardmaterial name:("Standard_"+(i as string))
		)
		--put the mats into the medit
		for i = 1 to theMats.count do
		(
			if i > 24 then exit
			meditmaterials[i] = theMats[i]
		)
		--open the mEdit
		MatEditor.Open()
	)
	
	parameters pblock rollout:RO_Renderer 
	( 
		theRenderer type:#maxObject
		theREs type:#maxObjectTab tabSizeVariable:true
		size type:#float animatable:true ui:amount default:4.0
		theMatObjs type:#stringTab tabSizeVariable:true
		theMats type:#materialTab tabSizeVariable:true
		passName type:#string ui:ET_PName default:""
		theXVisObjs type:#stringTab tabSizeVariable:true
	) 

	rollout RO_Renderer "Renderer" 
	( 
		Label LA_PName "RPM Pass Name:" align:#left 
		EditText ET_PName "" width:150 align:#center tooltip:"This field should contain the name of the RPM pass you want to build/modify. If you are not using RPM ignore this field. This is the exact name of the RPM pass that the tools in the 'RPM Tools' rollout will modify when used" 
		group "Renderer"
		(
			Label LA_Render "None"
			button BT_store "Store Renderer" width:145 align:#center tooltip:"Stores the current render as data attached to this object. Once stored, the class of the renderer will be displayed above this button, or 'None' if there is no renderer stored. You may merge this RenderHolder object into another scene to load and save render presets, or have multiple RenderHolder objects to store different render settings"
			button BT_assign "Assign To Current Renderer" width:145 align:#center offset:[0,-5] tooltip:"Assigns the render stored on this object to the current render. If using RPM, the current render will be overwritten by the stored RPM values. Please use the tools in the 'RPM Tolls' rollout when working with RPM passes"
			button BT_clear "Clear Renderer" width:145 align:#center offset:[0,-5] tooltip:"Removes the render data attached to this RenderHolder"
			Checkbox CB_StoreREs "Store/assign Rndr Elemets" offset:[-6,0] checked:true tooltip:"When checked, pressing the 'Store Renderer' button will also attach all current render elemnts to this RenderHolder. When checked, pressing the 'Assign to Current Renderer' button will DELETE current render elemets and assign the render elemets stored on this RenderHolder"
			Label LA_REs "Render Elements:" Align:#Left
			Listbox LB_REs "(Double Click to remove)" width:140 align:#center tooltip:"double click to remove" offset:[0,-7]
			Button BT_AppendREs "Append Current REs" width:145 align:#center tooltip:"Appends the current Render Elements to the above list."
		)
		group "Materials"
		(
			button BT_StoreMats "Store Materials" width:145 align:#center tooltip:"Stores a COPY of all materials that are assigned to objects in the scene and also a list of the object names that the materials was assigned to. Click on a material in the list below to see the list of objects that had that material assigned"
			button BT_AssignMats "Assign Materials" width:145 align:#center offset:[0,-5] tooltip:"Assigns a COPY of of the materials stored on this RenderHolder to the list of objects ascociated with the stored material. If the oject is not found by name it will be skipped"
			button BT_ClearMats "Clear Materials" width:145 align:#center offset:[0,-5] tooltip:"Removes all the material data stored on this RenderHolder"
			--Checkbox CB_SelectedMats "Only store/assign selected"
			Label LA_Ms "Object Materials:" Align:#Left
			Listbox LB_Mats "(Double Click to remove)" width:140 align:#center offset:[0,-7]
			Label LA_OMs "Objects assigned material:" Align:#Left
			Listbox LB_MatObjs "(Double Click to remove)" width:140 align:#center offset:[0,-7]
			Button BT_AppendMats "Append Current Materials" width:140 align:#center tooltip:"" offset:[0,-5] tooltip:"Appends a COPY of all materials that are assigned to objects in the scene and also a list of the object names that the materials was assigned to."
			button BT_InstAllMats2ME "Instance All Mats to Medit" width:140 align:#center offset:[0,-5] tooltip:"Clears the material editor and Instancess all the materials stored on this RenderHolder to the material editor. Any edits done in the material editor will be applied to the stored materials"
			button BT_InstSelMats2ME "Instance Sel Mats to Medit" width:140 align:#center offset:[0,-5] tooltip:"Clears the material editor and Instances the materials selected in the list above to the material editor. Any edits done in the material editor will be applied to the stored materials"

		)
		button BT_StoreAll "Store All" width:150 align:#center tooltip:"Pressing this will have the same effect as pressing the 'Store Renderer' and the 'Store Materials' buttons"
		button BT_AssignAll "Assign All" width:150 offset:[0,-5] align:#center tooltip:"Pressing this will have the same effect as pressing the 'Assign Renderer' and the 'Assign Materials' buttons"
		Button BT_ClearAll "Clear All" width:150 offset:[0,-5] align:#center tooltip:"Pressing this will have the same effect as pressing the 'Clear Renderer' and the 'Clear Materials' buttons"

		
		Spinner amount "Size:" range:[0, 1e9, 40]
		
		on BT_store pressed do
		(
			this.theRenderer = copy renderers.current
			LA_Render.text = ((classof theRenderer) as string)
			if CB_StoreREs.checked then
			(
				this.theREs = #()
				local theReMgr = MaxOps.GetCurRenderElementMgr()
				for i = 1 to theReMgr.NumRenderElements() do append this.theREs (copy (theReMgr.GetRenderElement (i-1)))
				LB_REs.items = for i in this.theREs collect i.elementName
			)	
			BT_assign.enabled = BT_clear.enabled = true
		)

		on BT_assign pressed do
		(
			--assign Renderer
			if this.theRenderer != undefined do renderers.current = this.theRenderer
			
			--assign REs
			if CB_StoreREs.checked then
			(
				if this.theREs != #() then
				(
					local theReMgr = MaxOps.GetCurRenderElementMgr()
					theReMgr.RemoveAllRenderElements()
					for i in this.theREs do theREMgr.AddRenderElement (copy i)
				)
			)
			
			if renderers.current == this.theRenderer then messagebox "Renderer assigned. " else messagebox "Error assigning renderer. "
			this.theRenderer = copy this.theRenderer 
		)
		on BT_clear pressed do
		(
			this.theRenderer = undefined
			LA_Render.text ="None"
			this.theREs = #()
			LB_REs.items = #()
			BT_assign.enabled = BT_clear.enabled = false
		)
		on LB_REs doubleClicked arg do
		(
			deleteItem this.theREs arg
			if this.theREs != #() then LB_REs.items = for i in this.theREs collect i.elementName
		)
		on BT_AppendREs pressed do
		(
				local theReMgr = MaxOps.GetCurRenderElementMgr()
				for i = 1 to theReMgr.NumRenderElements() do append this.theREs (copy (theReMgr.GetRenderElement (i-1)))
				LB_REs.items = for i in this.theREs collect i.elementName
		)
		

		on BT_StoreMats pressed do
		(
			this.theMats = #()
			this.theMatObjs = #()
			local theRenderers
			--if CB_SelectedMats.checked then theRenderers = for i in selection collect i else theRenderers = for i in objects collect i
			this.theMats = makeuniquearray (for i in objects where i.material != undefined collect i.material)
			for m in this.theMats do
			(
				objStr = ""
				for o in refs.dependentNodes m do
				(
					if o.material == m then append objstr (o.name+tok)
				)
				append this.theMatObjs objStr
			)
			LB_Mats.items = for i = 1 to this.theMats.count collect (this.theMats[i] as string)
			for i = 1 to this.theMats.count do this.theMats[i] = copy this.theMats[i]
			local filtNames = filterstring this.theMatObjs[1] tok
			LB_MatObjs.items = for i in filtNames collect i
			if this.theMats.count != 0 then BT_assignMats.enabled = BT_clearMats.enabled = true
			MakeTheMatsCopys()
		)

		on BT_AssignMats pressed do
		(
			--assign Materials
			--RPMclearscenematerials() -- clear scenematerials for speeeeeed!
			for i = 1 to this.theMats.count do
			(
				local filtNames = filterstring this.theMatObjs[i] tok
				for o in filtNames do
				(
					theRendererect = getnodebyname o
					if theRendererect == undefined then format "$% does not exist in scene, skipping material assignment\n"  o
					else try (theRendererect.material = this.theMats[i]) catch (format "unable to assign matrial '%' to object $%\n" this.theMats[i].name o)
				)
			)
			
			MakeTheMatsCopys()

			messagebox "Materials assigned. "
		)
		on BT_ClearMats pressed do
		(
			this.theMats = #()
			this.theMatObjs = #()
			LB_Mats.items = #()
			LB_MatObjs.items = #()
			BT_assignMats.enabled = BT_clearMats.enabled = false
		)
		
		on LB_Mats doubleClicked arg do
		(
			deleteItem this.theMats arg
			deleteItem this.theMatObjs arg
			
			LB_Mats.items = for i = 1 to this.theMats.count collect (this.theMats[i] as string)
			if LB_Mats.items.count != 0 and LB_Mats.selection == 0 then LB_Mats.selection = 1
			if LB_Mats.selection != 0 then
			(
				local filtNames = filterstring this.theMatObjs[LB_Mats.selection] tok
				LB_MatObjs.items = for i in filtNames collect i
			)
			else LB_MatObjs.items = #()
			if this.theMats.count != 0 then BT_assignMats.enabled = BT_clearMats.enabled = true
		)
		on LB_MatObjs doubleClicked arg do
		(
			filtNames = filterstring this.theMatObjs[LB_Mats.selection] tok
			deleteItem filtNames arg
			local objStr = ""
			for i in filtNames do append objStr (i+tok)
			this.theMatObjs[LB_Mats.selection] = objStr	
			if filtNames.count == 0 then 
			(
				deleteitem this.theMats LB_Mats.selection
				deleteitem this.theMatObjs LB_Mats.selection
			)
			
			LB_Mats.items = for i = 1 to this.theMats.count collect (this.theMats[i] as string)
			if LB_Mats.items.count != 0 and LB_Mats.selection == 0 then LB_Mats.selection = 1
			if LB_Mats.selection != 0 then
			(
				local filtNames = filterstring this.theMatObjs[LB_Mats.selection] tok
				LB_MatObjs.items = for i in filtNames collect i
			)
			else LB_MatObjs.items = #()
			if this.theMats.count != 0 then BT_assignMats.enabled = BT_clearMats.enabled = true	
			
		)		
		on BT_AppendMats pressed do
		(
			fn HasMat o = o.material != undefined
			theSel = selectByName Title:"Select objects to capture their materials" filter:hasMat
			local theNewMats = #()
			local theNewMatObjs = #()
			for o in theSel do
			(
				--remove the object if it alread exists
				for mo = 1 to this.theMatObjs.count do
				(
					filtNames = filterstring this.theMatObjs[mo] tok
					if (finditem filtNames o.name) != 0 then (deleteitem filtNames (finditem filtNames  o.name))
					objStr = ""
					for i in filtNames do append objStr (i+tok)
					this.theMatObjs[mo] = objStr
				)
				--Add the new objects material
				if o.material != undefined then append theNewMats o.material
			)
			theNewMats = makeuniquearray theNewMats
			for m in theNewMats do
			(
				theNewMatObjsStr = ""
				for o in theSel do
				(
					if o.material == m then append theNewMatObjsStr  (o.name+tok)
				)
				append theNewMatObjs theNewMatObjsStr
			)
			for i in theNewMats do append this.theMats i
			for i in theNewMatObjs do append this.theMatObjs i
			
			for i = this.theMats.count to 1 by -1 do
			(
				if this.theMatObjs[i].count == 0 then
				(
					deleteitem this.theMatObjs i
					deleteitem this.theMats i
				)
			)
			
			LB_Mats.items = for i = 1 to this.theMats.count collect (this.theMats[i] as string)
			
			if LB_Mats.items.count != 0 and LB_Mats.selection == 0 then LB_Mats.selection = 1
			local filtNames = filterstring this.theMatObjs[LB_Mats.selection] tok
			LB_MatObjs.items = for i in filtNames collect i
			if this.theMats.count != 0 then BT_assignMats.enabled = BT_clearMats.enabled = true
			MakeTheMatsCopys()
		)
		
		on BT_InstAllMats2ME pressed do
		(
			InstMats2Medit this.theMats
		)
		
		on BT_InstSelMats2ME pressed do
		(
			InstMats2Medit #(this.theMats[LB_Mats.selection])
		)	
		on LB_Mats selected arg do
		(
			local filtNames = filterstring this.theMatObjs[arg] tok
			LB_MatObjs.items = for i in filtNames collect i
		)

		on BT_storeAll pressed do
		(
			BT_store.pressed()
			BT_storeMats.pressed()
		)
		on BT_assignAll pressed do
		(
			BT_assign.pressed()
			BT_assignMats.pressed()
		)	
		on BT_clearAll pressed do
		(
			BT_clear.pressed()
			BT_clearMats.pressed()
		)
		on ET_PName entered arg do
		(
			this.passName = arg
		)
		on RO_Renderer open do
		(
			--this.passName = (refs.dependentNodes this firstOnly:true).name
			
			if theRenderer != undefined then
			(
				BT_assign.enabled = BT_clear.enabled = true
				LA_Render.text = ((classof theRenderer) as string)
				if this.theREs != #() then LB_REs.items = for i in this.theREs collect i.elementName
			)
			else
			(
				BT_assign.enabled = BT_clear.enabled = false
				LA_Render.text ="None"
			)
			
			LB_Mats.items = for i = 1 to this.theMats.count collect (this.theMats[i] as string)
			if LB_Mats.items.count > 0 then
			(
				local filtNames = filterstring this.theMatObjs[1] tok
				LB_MatObjs.items = for i in filtNames collect i
			)
			else
			(
				BT_assignMats.enabled = BT_clearMats.enabled = false
			)
			
			if zc == undefined then --== Crate a Dummy instance of the Zorb Debug Console if it dosent exist
			(
				global zc
				struct zorbConsoleReplacement
				(
					class = "zorbConsoleReplacement",
					enableLog = false,
					fn AddLog arr= format "%: %: %" arr[1] arr[2] (arr[3] as string)
				)
				zc = zorbConsoleReplacement()
			)
		)
	)
	rollout RO_Objs "Objects"
	(
		group "Extra RPM VisSet Objects"
		(
			Label LA_XVisObs "Extra Objects:" Align:#Left
			Listbox LB_XVisObjs "(Double Click to remove)" width:140 align:#center offset:[0,-7]
			Button BT_XVisObjsAppend "Append Object List" width:140 align:#center tooltip:"Brings up a 'Select Objects' dialog to add object names to the above list. This list will be used when using the 'Build/Update RPM pass' to create a visibility set based on the list of names. If an object's name is listed and it is not found in the scene it will be skipped"
		)
		--this.theXVisObjs
		on RO_Objs open do
		(
			LB_XVisObjs.items = for i in this.theXVisObjs collect i
		)
		on BT_XVisObjsAppend pressed do
		(
			local theRenderers = selectByName title:"Select objects to be added to visSet"
			for o in theRenderers do append this.theXVisObjs o.name
			LB_XVisObjs.items = for i in this.theXVisObjs collect i
		)
		on LB_XVisObjs doubleclicked arg do
		(
			deleteitem this.theXVisObjs arg
			LB_XVisObjs.items = for i in this.theXVisObjs collect i
		)
			
	)
	rollout RO_RPMTools "RPM Tools"
	(
		group "Renderer"
		(
			button BT_AssignRPM "Update RPM Pass Renderer" width:145 align:#center tooltip:"Assigns renderer to an RPM pass with the same name as specified in the 'RPM Pass Name' on this RenderHolder. DOES NOT ASSIGN TO THE CURRENT RPM PASS"
			checkbox CB_AssignREs "Assign REs with Renderer" checked:true offset:[-6,0] tooltip:"When checked and 'Update RPM Pass Renderer' is pressed the render elements assigned to the RPM pass with the same name as specified in the 'RPM Pass Name' will be removed and replaced with the render elements stored on this RenderHolder"
			button BT_AssignRPMREs "Update RPM Pass REs Only" width:145 align:#center tooltip:"Assigns only the Render Elements to an RPM pass with the same name as this renderHolder"
			button BT_AppendRPMREs "Append RPM Pass REs Only" width:145 offset:[0,-5] align:#center tooltip:"Appends only the Render Elements to an RPM pass with the same name as this renderHolder, will skip render elements that have the same name"
		)
		group "Materials"
		(
			Button BT_UpdateMats "Update RPM Pass Materials" width:145 align:#center tooltip:"Pushes the materials to objects only if it finds an instance of the material. Will search thorugh the material and replace it in the correct slot"
			checkbox CB_BuildRPMMats "Build with RPM Mats" checked:true
			checkbox CB_ForceRebuldMats "Force Rebuild Mats" tooltip:"Forces a rebuild of the materials if checked. If unchecked searches existing material sub materials and repaces if found. eg, trys to preserve RPM materials"
		)
		Button BT_BuildPass "Builds/Updates RPM pass" width:150 align:#center tooltip:"Builds an new RPM pass based on the settings stored on this RenderHolder if there are no passes with the same name as the 'RPM Pass Name' field. If an RPM pass with the same name is found it will update that pass based on settings stored on this RenderHolder"
		checkbox CB_showlog "Show Log" across:2 checked:true
		button BT_ShowLog "Open Log" height:16
		
		on RO_RPMTools open do
		(
			if RPMData == undefined then
			(
				BT_AssignRPM.enabled = CB_AssignREs.enabled = BT_AssignRPMREs.enabled = BT_AppendRPMREs.enabled = BT_UpdateMats.enabled = CB_BuildRPMMats.enabled = CB_ForceRebuldMats.enabled = BT_BuildPass.enabled = false
			)
			
			if zc != undefined then
			(
				if zc.class == "zorbConsoleReplacement" then
				(
					CB_showLog.checked = false
					CB_showLog.enabled = BT_showLog.enabled = false
				)
			)
		)
		
		on BT_ShowLog pressed do zc.showme()
		on BT_AssignRPM pressed do
		(
			if CB_showlog.checked then zc.ShowMe()
			fnName = "RenderHolder.RO_RPMTools.BT_AssignRPM"
			zc.AddLog #(fnName,  "Starting", 5)
			
			theLogArr = #()
			if RPMData != undefined then
			(
				passindex = 0
				for p = 1 to (RPMdata.GetPassCount()) do
				(
					thePassName = RPMdata.GetPassName p
					if (tolower thepassName) == (tolower this.passName) then passindex = p
				)
				if passindex != 0 then
				(
					zc.AddLog #(fnName,  ("Found RPM pass: "+this.passName+" at index "+passindex as string+". Assiging renderer"), 4)
					applyRenderToRPM passIndex
					if CB_AssignREs.checked then applyRenderToRPMREs passIndex
				)
				else
				(
					zc.AddLog #(fnName,  "Could not find RPM pass: "+this.passName+". Not assiging renderer", 3)
					messagebox "Could not find matching pass to assign renderer to"
				)
			)
		)
		
		on BT_AssignRPMREs pressed do
		(
			if CB_showlog.checked then zc.ShowMe()
			fnName = "RenderHolder.RO_RPMTools.BT_AssignRPMREs"
			zc.AddLog #(fnName,  "Starting", 5)
			
			theLogArr = #()
			if RPMData != undefined then
			(
				passindex = 0
				for p = 1 to (RPMdata.GetPassCount()) do
				(
					thePassName = RPMdata.GetPassName p
					if (tolower thepassName) == (tolower this.passName) then passindex = p
				)
				if passindex != 0 then
				(
					zc.AddLog #(fnName,  ("Found RPM pass: "+this.passName+" at index "+passindex as string+". Assiging Render Elements"), 4)
					--applyRenderToRPM passIndex applyREs:CB_AssignREs.checked
					applyRenderToRPMREs passIndex
				)
				else
				(
					zc.AddLog #(fnName,  "Could not find RPM pass: "+this.passName+". Not assiging Render Elementsr", 3)
					messagebox "Could not find matching pass to assign Render Elements to"
				)
			)			
		)

		on BT_AppendRPMREs pressed do
		(
			if CB_showlog.checked then zc.ShowMe()
			fnName = "RenderHolder.RO_RPMTools.BT_AppendRPMREs"
			zc.AddLog #(fnName,  "Starting", 5)
			
			theLogArr = #()
			if RPMData != undefined then
			(
				passindex = 0
				for p = 1 to (RPMdata.GetPassCount()) do
				(
					thePassName = RPMdata.GetPassName p
					if (tolower thepassName) == (tolower this.passName) then passindex = p
				)
				if passindex != 0 then
				(
					zc.AddLog #(fnName,  ("Found RPM pass: "+this.passName+" at index "+passindex as string+". Appending Render Elements"), 4)
					--applyRenderToRPM passIndex applyREs:CB_AssignREs.checked
					applyRenderToRPMREs passIndex doAppend:true
				)
				else
				(
					zc.AddLog #(fnName,  "Could not find RPM pass: "+this.passName+". Not appending Render Elementsr", 3)
					messagebox "Could not find matching pass to append Render Elements to"
				)
			)			
		)
		
		on BT_UpdateMats pressed do
		(
			if CB_showlog.checked then zc.ShowMe()
			
			fnName = "RenderHolder.RO_RPMTools.BT_UpdateMats"
			zc.AddLog #(fnName,  "Starting", 5)
			
			theLogArr = #()
			if RPMData != undefined then
			(
				passindex = 0
				for p = 1 to (RPMdata.GetPassCount()) do
				(
					thePassName = RPMdata.GetPassName p
					if (tolower thepassName) == (tolower this.passName) then passindex = p
				)
				if passindex != 0 then
				(
					zc.AddLog #(fnName,  "Found RPM pass: "+this.passName+" at index "+passindex as string+". Assiging materials", 4)
					applyMatsToRPM passIndex buildRPMmat:CB_buildRPMMats.checked forceRebuild:CB_ForceRebuldMats.checked
				)
				else
				(
					zc.AddLog #(fnName,  "Could not find RPM pass: "+this.passName+". Not assiging materials", 3)
					messagebox "Could not find matching pass to assign materials to"
				)
			)
		)
		on BT_BuildPass pressed do
		(
			if CB_showlog.checked then zc.ShowMe()
			fnName = "RenderHolder.RO_RPMTools.BT_BuildPass"
			zc.AddLog #(fnName,  "Starting", 5)
			
			--this.passName = (refs.dependentNodes this firstOnly:true).name
			theLogArr = #()
			if RPMdata == undefined then
			(
				try (macros.run "RPManager" "RPManager")
				catch
				(
					messagebox "RPM not found."
					zc.AddLog #(fnName,  "RPM not found", 2)
				)
				
			)
			else
			(
				DialogMonitorOPS.RegisterNotification SkipBloodyDialogs id:#SkipBloodyDialogs 
				DialogMonitorOPS.Enabled = true
				
				RPMdata.RMopenFloater()
				RPMdata.RMrefresh()
				zc.AddLog #(fnName,  "RPM Setup: Begin RPM setup", 4)
				--append theLogArr #(("RPM Setup: Begin RPM setup"), "info")
				
				--close render dialog first
				renderSceneDialogWasOpen = renderSceneDialog.isOpen()
				if renderSceneDialogWasOpen then renderSceneDialog.close()
				
				passindex = 0
				for p = 1 to (RPMdata.GetPassCount()) do
				(
					thePassName = RPMdata.GetPassName p
					if (tolower thepassName) == (tolower this.passName) then passindex = p
				)
				
				builtPassIndex = BuildRPMpass passindex
				applyRenderToRPM builtPassIndex
				if CB_AssignREs.checked then applyRenderToRPMREs builtPassIndex
				applyMatsToRPM builtPassIndex buildRPMmat:CB_buildRPMMats.checked forceRebuild:CB_ForceRebuldMats.checked
				
				
				DialogMonitorOPS.unRegisterNotification id:#SkipBloodyDialogs 
				DialogMonitorOPS.Enabled = false
				--open the render dialog if it was open
				if renderSceneDialogWasOpen then renderSceneDialog.open()
			)
		)
	)
	
	rollout RO_About "About"
	(
		Label LA_About_10 "Render Holder Zorb"
		Label LA_About_15 "v1.7"
		Label LA_About_20 "by Jordan Walsh"
		Label LA_About_30 "jordan.h.walsh@gmail.com"
	)

	on getDisplayMesh do 
	(
		if meshObj == undefined do 
		(
			meshObj = createInstance teapot radius:size mapCoords:false segments:2
			lastSize = size
		)

		if size != lastSize do 
		(
			meshObj.radius = size
			lastSize = size
		)
		meshObj.mesh
	)

	tool create
	(
		on mousePoint click do
		case click of
		(
			1: nodeTM.translation = gridPoint
			2: #stop
		)
	on mouseMove click do
		case click of
		(
			2: (size = gridDist.x)
			--3: height = gridDist.z
		)
  )

)